Imports FarPoint.Win.Spread.DrawingSpace
Imports System.Drawing.Drawing2D

Public Class SpreadPropertyGrid
   Inherits PropertyGrid
   Implements FarPoint.Win.Spread.DrawingSpace.IEmbeddedControlSupport

   Private _moving As FarPoint.Win.Spread.DrawingSpace.Moving = Moving.None
   Private _sizing As FarPoint.Win.Spread.DrawingSpace.Sizing = Sizing.None
   Private _activation As FarPoint.Win.Spread.DrawingSpace.ChildActivationPolicy = ChildActivationPolicy.DoubleClick

   Public Overridable Property ActivationPolicy() As FarPoint.Win.Spread.DrawingSpace.ChildActivationPolicy Implements IEmbeddedControlSupport.ActivationPolicy
   Get
     Return _activation
   End Get
   Set(ByVal Value As FarPoint.Win.Spread.DrawingSpace.ChildActivationPolicy)
     _activation = Value
   End Set
   End Property

   Public Overridable Property CanMove() As FarPoint.Win.Spread.DrawingSpace.Moving Implements IEmbeddedControlSupport.CanMove
   Get
     Return _moving
   End Get
   Set(ByVal Value As FarPoint.Win.Spread.DrawingSpace.Moving)
     _moving = Value
   End Set
   End Property

   Public Overridable Property CanSize() As FarPoint.Win.Spread.DrawingSpace.Sizing Implements IEmbeddedControlSupport.CanSize
   Get
     Return _sizing
   End Get
   Set(ByVal Value As FarPoint.Win.Spread.DrawingSpace.Sizing)
     _sizing = Value
   End Set
   End Property

   Public Sub ControlPaint(ByVal g As Graphics, ByVal r As Rectangle, ByVal appearance As FarPoint.Win.Spread.Appearance, ByVal value As Object, ByVal isSelected As Boolean, ByVal isLocked As Boolean, ByVal zoomFactor As Single) Implements IEmbeddedControlSupport.ControlPaint
     Dim str As String = Nothing
     If Not (value Is Nothing) Then
       If TypeOf value Is String Then
         str = CStr(value)
       Else
         str = value.ToString()
       End If
     End If
 Dim rgn As Region = g.Clip
     g.SetClip(r, Drawing2D.CombineMode.Intersect)

     g.FillRectangle(New SolidBrush(Me.BackColor), r)
     g.DrawString("PropertyGrid", Font, New SolidBrush(Color.White), r.X, r.Y)
 g.SetClip(rgn, CombineMode.Replace)
  End Sub

End Class

Public Class SpreadTextBox
   Inherits TextBox
   Implements FarPoint.Win.Spread.DrawingSpace.IEmbeddedControlSupport

   Private _moving As FarPoint.Win.Spread.DrawingSpace.Moving = Moving.None
   Private _sizing As FarPoint.Win.Spread.DrawingSpace.Sizing = Sizing.None
   Private _activation As FarPoint.Win.Spread.DrawingSpace.ChildActivationPolicy = ChildActivationPolicy.DoubleClick

Public Sub New()
AddHandler Me.TextChanged, AddressOf Me_TextChanged

End Sub
   Public Overridable Property ActivationPolicy() As FarPoint.Win.Spread.DrawingSpace.ChildActivationPolicy Implements IEmbeddedControlSupport.ActivationPolicy
   Get
     Return _activation
   End Get
   Set(ByVal Value As FarPoint.Win.Spread.DrawingSpace.ChildActivationPolicy)
     ' _activation = Value
   End Set
   End Property

   Public Overridable Property CanMove() As FarPoint.Win.Spread.DrawingSpace.Moving Implements IEmbeddedControlSupport.CanMove
   Get
     Return _moving
   End Get
   Set(ByVal Value As FarPoint.Win.Spread.DrawingSpace.Moving)
     _moving = Value
   End Set
   End Property

   Public Overridable Property CanSize() As FarPoint.Win.Spread.DrawingSpace.Sizing Implements IEmbeddedControlSupport.CanSize
   Get
     Return _sizing
   End Get
   Set(ByVal Value As FarPoint.Win.Spread.DrawingSpace.Sizing)
     _sizing = Value
   End Set
   End Property


   Public Sub ControlPaint(ByVal g As Graphics, ByVal r As Rectangle, ByVal appearance As FarPoint.Win.Spread.Appearance, ByVal value As Object, ByVal isSelected As Boolean, ByVal isLocked As Boolean, ByVal zoomFactor As Single) Implements IEmbeddedControlSupport.ControlPaint
Dim rgn As Region = g.Clip
g.SetClip(r, Drawing2D.CombineMode.Intersect)
    g.FillRectangle(New SolidBrush(Me.BackColor), r)
'g.FillRectangle(New SolidBrush(Me.BackColor), r.X - 120, r.Y - 120, r.Width, r.Height)
    g.DrawString(Me.Text, Font, New SolidBrush(Me.ForeColor), r.X, r.Y)
g.SetClip(rgn, CombineMode.Replace)
  End Sub

Public Sub Me_TextChanged(ByVal sender As Object, ByVal e As EventArgs)
Me.BackColor = Color.Beige
End Sub
End Class

Public Class SpreadRadioButton
   Inherits RadioButton
   Implements FarPoint.Win.Spread.DrawingSpace.IEmbeddedControlSupport

   Private _moving As FarPoint.Win.Spread.DrawingSpace.Moving = Moving.None
   Private _sizing As FarPoint.Win.Spread.DrawingSpace.Sizing = Sizing.None
   Private _activation As FarPoint.Win.Spread.DrawingSpace.ChildActivationPolicy = ChildActivationPolicy.Click

Public Sub New()
AddHandler Me.CheckedChanged, AddressOf Me_CheckChanged
End Sub
   Public Overridable Property ActivationPolicy() As FarPoint.Win.Spread.DrawingSpace.ChildActivationPolicy Implements IEmbeddedControlSupport.ActivationPolicy
   Get
     Return _activation
   End Get
   Set(ByVal Value As FarPoint.Win.Spread.DrawingSpace.ChildActivationPolicy)
     ' _activation = Value
   End Set
   End Property

   Public Overridable Property CanMove() As FarPoint.Win.Spread.DrawingSpace.Moving Implements IEmbeddedControlSupport.CanMove
   Get
     Return _moving
   End Get
   Set(ByVal Value As FarPoint.Win.Spread.DrawingSpace.Moving)
     _moving = Value
   End Set
   End Property

   Public Overridable Property CanSize() As FarPoint.Win.Spread.DrawingSpace.Sizing Implements IEmbeddedControlSupport.CanSize
   Get
     Return _sizing
   End Get
   Set(ByVal Value As FarPoint.Win.Spread.DrawingSpace.Sizing)
     _sizing = Value
   End Set
   End Property

   Public Sub ControlPaint(ByVal g As Graphics, ByVal r As Rectangle, ByVal appearance As FarPoint.Win.Spread.Appearance, ByVal value As Object, ByVal isSelected As Boolean, ByVal isLocked As Boolean, ByVal zoomFactor As Single) Implements IEmbeddedControlSupport.ControlPaint
Dim rgn As Region = g.Clip

g.SetClip(r, Drawing2D.CombineMode.Intersect)

     r = New Rectangle(r.X, r.Y, Math.Min(Me.Width, 12), Math.Min(Me.Height, 16))

     If Me.Checked = True Then
       System.Windows.Forms.ControlPaint.DrawRadioButton(g, r, ButtonState.Checked)
     Else
       System.Windows.Forms.ControlPaint.DrawRadioButton(g, r, ButtonState.Normal)
     End If
     If (Me.ForeColor.IsEmpty) Then
       g.DrawString(Me.Text, Me.Font, New SolidBrush(Color.Black), r.X + r.Width, r.Y)
     Else
       g.DrawString(Me.Text, Me.Font, New SolidBrush(Me.ForeColor), r.X + r.Width, r.Y)
     End If
g.SetClip(rgn, CombineMode.Replace)
   End Sub

Public Sub Me_CheckChanged(ByVal sender As Object, ByVal e As System.EventArgs)

Me.BackColor = Color.Plum


End Sub

End Class

Public Class SpreadCheckBox
   Inherits CheckBox
   Implements FarPoint.Win.Spread.DrawingSpace.IEmbeddedControlSupport

   Private _moving As FarPoint.Win.Spread.DrawingSpace.Moving = Moving.None
   Private _sizing As FarPoint.Win.Spread.DrawingSpace.Sizing = Sizing.None
   Private _activation As FarPoint.Win.Spread.DrawingSpace.ChildActivationPolicy = ChildActivationPolicy.Click

Public Sub New()
AddHandler Me.CheckStateChanged, AddressOf Me_CheckStateChanged
End Sub
   Public Overridable Property ActivationPolicy() As FarPoint.Win.Spread.DrawingSpace.ChildActivationPolicy Implements IEmbeddedControlSupport.ActivationPolicy
   Get
     Return _activation
   End Get
   Set(ByVal Value As FarPoint.Win.Spread.DrawingSpace.ChildActivationPolicy)
     _activation = Value
   End Set
   End Property

   Public Overridable Property CanMove() As FarPoint.Win.Spread.DrawingSpace.Moving Implements IEmbeddedControlSupport.CanMove
   Get
     Return _moving
   End Get
   Set(ByVal Value As FarPoint.Win.Spread.DrawingSpace.Moving)
     _moving = Value
   End Set
   End Property

   Public Overridable Property CanSize() As FarPoint.Win.Spread.DrawingSpace.Sizing Implements IEmbeddedControlSupport.CanSize
   Get
     Return _sizing
   End Get
   Set(ByVal Value As FarPoint.Win.Spread.DrawingSpace.Sizing)
     _sizing = Value
   End Set
   End Property

   Public Sub ControlPaint(ByVal g As Graphics, ByVal r As Rectangle, ByVal appearance As FarPoint.Win.Spread.Appearance, ByVal value As Object, ByVal isSelected As Boolean, ByVal isLocked As Boolean, ByVal zoomFactor As Single) Implements IEmbeddedControlSupport.ControlPaint
Dim rgn As Region = g.Clip
g.SetClip(r, Drawing2D.CombineMode.Intersect)

     r = New Rectangle(r.X, r.Y, Me.Width, Me.Height)


     If isSelected = True Then
       System.Windows.Forms.ControlPaint.DrawCheckBox(g, r, ButtonState.Checked)
     Else
       System.Windows.Forms.ControlPaint.DrawCheckBox(g, r, ButtonState.Normal)
     End If

g.SetClip(rgn, CombineMode.Replace)
   End Sub

Public Sub Me_CheckStateChanged(ByVal sender As Object, ByVal e As System.EventArgs)

If Me.CheckState = Windows.Forms.CheckState.Checked Then
Me.BackColor = Color.Green
Else
Me.BackColor = Color.Coral
End If
End Sub

End Class

Public Class SpreadComboBox
   Inherits ComboBox
   Implements FarPoint.Win.Spread.DrawingSpace.IEmbeddedControlSupport

   Private _moving As FarPoint.Win.Spread.DrawingSpace.Moving = Moving.None
   Private _sizing As FarPoint.Win.Spread.DrawingSpace.Sizing = Sizing.None
   Private _activation As FarPoint.Win.Spread.DrawingSpace.ChildActivationPolicy = ChildActivationPolicy.Click

Public Sub New()
AddHandler Me.SelectedValueChanged, AddressOf Me_SelectedValueChanged
End Sub
   Public Overridable Property ActivationPolicy() As FarPoint.Win.Spread.DrawingSpace.ChildActivationPolicy Implements IEmbeddedControlSupport.ActivationPolicy
   Get
     Return _activation
   End Get
   Set(ByVal Value As FarPoint.Win.Spread.DrawingSpace.ChildActivationPolicy)
     ' _activation = Value
   End Set
   End Property

   Public Overridable Property CanMove() As FarPoint.Win.Spread.DrawingSpace.Moving Implements IEmbeddedControlSupport.CanMove
   Get
     Return _moving
   End Get
   Set(ByVal Value As FarPoint.Win.Spread.DrawingSpace.Moving)
     _moving = Value
   End Set
   End Property

   Public Overridable Property CanSize() As FarPoint.Win.Spread.DrawingSpace.Sizing Implements IEmbeddedControlSupport.CanSize
   Get
     Return _sizing
   End Get
   Set(ByVal Value As FarPoint.Win.Spread.DrawingSpace.Sizing)
     _sizing = Value
   End Set
   End Property

   Public Sub ControlPaint(ByVal g As Graphics, ByVal r As Rectangle, ByVal appearance As FarPoint.Win.Spread.Appearance, ByVal value As Object, ByVal isSelected As Boolean, ByVal isLocked As Boolean, ByVal zoomFactor As Single) Implements IEmbeddedControlSupport.ControlPaint
Dim rgn As Region = g.Clip
g.SetClip(r, Drawing2D.CombineMode.Intersect)
     r = New Rectangle(r.X, r.Y, Me.Width, Me.Height)
     g.FillRectangle(New SolidBrush(Color.Yellow), r)
     g.DrawString("ComboBox", Font, New SolidBrush(Color.Black), r.X, r.Y)
     r.X = r.X + r.Width - SystemInformation.CaptionButtonSize.Width
     r.Width = SystemInformation.CaptionButtonSize.Width
     System.Windows.Forms.ControlPaint.DrawComboButton(g, r, ButtonState.Normal)

g.SetClip(rgn, CombineMode.Replace)
   End Sub

Public Sub Me_SelectedValueChanged(ByVal sender As Object, ByVal e As EventArgs)
Me.BackColor = Color.Orange
End Sub

End Class

Public Class SpreadButton
Inherits Button
Implements FarPoint.Win.Spread.DrawingSpace.IEmbeddedControlSupport

Private _moving As FarPoint.Win.Spread.DrawingSpace.Moving = Moving.None
Private _sizing As FarPoint.Win.Spread.DrawingSpace.Sizing = Sizing.None
Private _activation As FarPoint.Win.Spread.DrawingSpace.ChildActivationPolicy = ChildActivationPolicy.Click

Public Sub New()
AddHandler Me.Click, AddressOf Me_Click
End Sub

Public Property ActivationPolicy() As FarPoint.Win.Spread.DrawingSpace.ChildActivationPolicy Implements FarPoint.Win.Spread.DrawingSpace.IEmbeddedControlSupport.ActivationPolicy
Get
Return _activation
End Get
Set(ByVal value As FarPoint.Win.Spread.DrawingSpace.ChildActivationPolicy)
'_activation = value
End Set
End Property

Public Property CanMove() As FarPoint.Win.Spread.DrawingSpace.Moving Implements FarPoint.Win.Spread.DrawingSpace.IEmbeddedControlSupport.CanMove
Get
Return _moving
End Get
Set(ByVal value As FarPoint.Win.Spread.DrawingSpace.Moving)
_moving = value
End Set
End Property

Public Property CanSize() As FarPoint.Win.Spread.DrawingSpace.Sizing Implements FarPoint.Win.Spread.DrawingSpace.IEmbeddedControlSupport.CanSize
Get
Return _sizing
End Get
Set(ByVal value As FarPoint.Win.Spread.DrawingSpace.Sizing)
_sizing = value
End Set
End Property

Public Sub ControlPaint(ByVal g As System.Drawing.Graphics, ByVal r As System.Drawing.Rectangle, ByVal appearance As FarPoint.Win.Spread.Appearance, ByVal value As Object, ByVal isSelected As Boolean, ByVal isLocked As Boolean, ByVal zoomFactor As Single) Implements FarPoint.Win.Spread.DrawingSpace.IEmbeddedControlSupport.ControlPaint
Dim rgn As Region = g.Clip
g.SetClip(r, Drawing2D.CombineMode.Intersect)
r = New Rectangle(r.X, r.Y, Me.Width, Me.Height)
g.FillRectangle(New SolidBrush(Color.Yellow), r)
System.Windows.Forms.ControlPaint.DrawButton(g, r, ButtonState.All)
g.SetClip(rgn, CombineMode.Replace)

End Sub

Public Sub Me_Click(ByVal sender As Object, ByVal e As System.EventArgs)
Me.BackColor = Color.Red
End Sub
End Class

